commit 907fd5049735ed1bd17e221db5a812dedee5dfc8
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Fri Nov 5 23:48:20 2021

    Fortran: fix simplification of array-valued parameter expressions
    
    gcc/fortran/ChangeLog:
    
            PR fortran/102817
            * expr.c (simplify_parameter_variable): Copy shape of referenced
            subobject when simplifying.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/102817
            * gfortran.dg/pr102817.f90: New test.
    
    (cherry picked from commit bcf3728abe8488882922005166d3065fc5fdfea1)

diff --git a/gcc/fortran/expr.c b/gcc/fortran/expr.c
index 6c38935adc3..186e860e382 100644
--- a/gcc/fortran/expr.c
+++ b/gcc/fortran/expr.c
@@ -2126,6 +2126,8 @@ simplify_parameter_variable (gfc_expr *p, int type)
       if (e == NULL)
 	return false;
 
+      gfc_free_shape (&e->shape, e->rank);
+      e->shape = gfc_copy_shape (p->shape, p->rank);
       e->rank = p->rank;
 
       if (e->ts.type == BT_CHARACTER && p->ts.u.cl)
diff --git a/gcc/testsuite/gfortran.dg/pr102817.f90 b/gcc/testsuite/gfortran.dg/pr102817.f90
new file mode 100644
index 00000000000..c081a69f0ea
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/pr102817.f90
@@ -0,0 +1,17 @@
+! { dg-do compile }
+! PR fortran/102817 - ICE in gfc_clear_shape
+
+program test
+  type t
+     integer :: a(1,2) = 3
+  end type t
+  type(t), parameter :: u    = t(4)
+  type(t), parameter :: x(1) = t(4)
+  integer, parameter :: p(1,2) = (x(1)%a)
+  integer            :: z(1,2) = (x(1)%a) 
+  integer            :: y(1,2), v(1,2), w(1,2)
+  v = (u   %a)
+  w =  x(1)%a
+  y = (x(1)%a)
+  print *, v, w, y, z, p
+end

